diff -Naur -X diff_ignore rsync-3.0.6_base/generator.c rsync/generator.c
--- rsync-3.0.6_base/generator.c	2009-06-18 17:30:50.000000000 -0400
+++ rsync/generator.c	2019-01-14 17:30:40.000000000 -0500
@@ -22,6 +22,8 @@
 
 #include "rsync.h"
 #include "ifuncs.h"
+// For _PATH_RSRCFORKSPEC
+#include <sys/paths.h>
 
 extern int verbose;
 extern int dry_run;
@@ -38,15 +40,21 @@
 extern int keep_dirlinks;
 extern int preserve_acls;
 extern int preserve_xattrs;
+extern int preserve_hfs_compression;
+extern int fs_supports_hfs_compression;
+extern int fs_supports_native_xattrs;
+extern uid_t receiver_uid;
+extern int replace_dirs_with_diff_type;
+extern int delete_deleted;
 extern int preserve_links;
 extern int preserve_devices;
 extern int preserve_specials;
 extern int preserve_fileflags;
 extern int preserve_hard_links;
 extern int preserve_executability;
-extern int preserve_fileflags;
 extern int preserve_perms;
 extern int preserve_times;
+extern int sparse_files;
 extern int force_change;
 extern int uid_ndx;
 extern int gid_ndx;
@@ -105,6 +113,13 @@
 extern int backup_suffix_dels_len;
 extern struct file_list *cur_flist, *first_flist, *dir_flist;
 extern struct filter_list_struct daemon_filter_list;
+extern int detect_case_conflicts;
+
+extern int write_size;
+extern const char *srcRoot;
+extern const char *dstRoot;
+int64 sparseDataCopied = 0;
+int sparseFilesCopied = 0;
 
 int ignore_perishable = 0;
 int non_perishable_cnt = 0;
@@ -121,6 +136,16 @@
 static int need_retouch_dir_times;
 static int need_retouch_dir_perms;
 static const char *solo_file = NULL;
+  
+// BOMBICH
+struct timeval last_update;
+static unsigned long msdiff(struct timeval *t1, struct timeval *t2)
+{
+	return (t2->tv_sec - t1->tv_sec) * 1000L
+		+ (t2->tv_usec - t1->tv_usec) / 1000;
+}
+
+extern time_t last_hb;
 
 /* For calling delete_item() and delete_dir_contents(). */
 #define DEL_NO_UID_WRITE 	(1<<0) /* file/dir has our uid w/o write perm */
@@ -131,6 +156,7 @@
 #define DEL_FOR_SYMLINK 	(1<<5) /* making room for a replacement symlink */
 #define DEL_FOR_DEVICE		(1<<6) /* making room for a replacement device */
 #define DEL_FOR_SPECIAL 	(1<<7) /* making room for a replacement special */
+#define DEL_APPLE_DOUBLES	(1<<8) /* BOMBICH */
 
 #define DEL_MAKE_ROOM (DEL_FOR_FILE|DEL_FOR_DIR|DEL_FOR_SYMLINK|DEL_FOR_DEVICE|DEL_FOR_SPECIAL)
 
@@ -177,6 +203,21 @@
 			fbuf, (int)mode, (int)flags);
 	}
 
+	// BOMBICH -- If we're replacing an item, delete everything in a directory too to avoid the annoying errors (e.g. if the user didn't choose the delete option)
+	if (replace_dirs_with_diff_type && flags & DEL_MAKE_ROOM)
+		flags |= DEL_RECURSE;
+
+	heartbeat(fbuf);
+		
+	// BOMBICH
+	// If an entire folder's contents are going to be archived, just move the whole folder
+	if (S_ISDIR(mode) && make_backups > 0 && delete_deleted == 0) {
+		ok = safe_delete(fbuf);
+		if (ok)
+			ret = DR_SUCCESS;
+		goto check_ret;
+	}	
+
 	if (flags & DEL_NO_UID_WRITE)
 		do_chmod(fbuf, mode | S_IWUSR, NO_FFLAGS);
 
@@ -193,6 +234,10 @@
 				make_mutable(fbuf, st.st_mode, st.st_flags, force_change);
 		}
 #endif
+
+		// BOMBICH -- If we're deleting an entire folder, override the ._ protect rule
+		flags |= DEL_APPLE_DOUBLES;
+
 		ignore_perishable = 1;
 		/* If DEL_RECURSE is not set, this just reports emptiness. */
 		ret = delete_dir_contents(fbuf, flags);
@@ -212,7 +257,7 @@
 	if (S_ISDIR(mode)) {
 		what = "rmdir";
 		ok = do_rmdir(fbuf) == 0;
-	} else if (make_backups > 0 && (backup_dir_dels || !is_backup_file(fbuf))) {
+	} else if (delete_deleted == 0 && make_backups > 0 && (backup_dir_dels || !is_backup_file(fbuf))) {
 		what = "make_backup";
 		ok = safe_delete(fbuf);
 	} else {
@@ -221,17 +266,17 @@
 	}
 
 	if (ok) {
-		if (!(flags & DEL_MAKE_ROOM))
+		if (!(flags & DEL_MAKE_ROOM) && make_backups == 0)
 			log_delete(fbuf, mode);
 		ret = DR_SUCCESS;
 	} else {
 		if (S_ISDIR(mode) && errno == ENOTEMPTY) {
-			rprintf(FINFO, "cannot delete non-empty directory: %s\n",
-				fbuf);
+			rprintf(FERROR, "cannot delete non-empty directory: %s\n",
+				full_fname(fbuf));
 			ret = DR_NOT_EMPTY;
 		} else if (errno != ENOENT) {
-			rsyserr(FERROR, errno, "delete_file: %s(%s) failed",
-				what, fbuf);
+			rsyserr(FERROR, errno, "delete_item: %s(%s) failed",
+				what, full_fname(fbuf));
 			ret = DR_FAILURE;
 		} else {
 			deletion_count--;
@@ -251,7 +296,7 @@
 		default: exit_cleanup(RERR_UNSUPPORTED); /* IMPOSSIBLE */
 		}
 		rprintf(FERROR_XFER, "could not make way for new %s: %s\n",
-			desc, fbuf);
+			desc, full_fname(fbuf));
 	}
 	return ret;
 }
@@ -269,6 +314,7 @@
 	void *save_filters;
 	int j, dlen;
 	char *p;
+	int ignore_filters = (flags & DEL_APPLE_DOUBLES) > 0 ? 1 : 0; // BOMBICH
 
 	if (verbose > 3) {
 		rprintf(FINFO, "delete_dir_contents(%s) flags=%d\n",
@@ -279,7 +325,7 @@
 	save_filters = push_local_filters(fname, dlen);
 
 	non_perishable_cnt = 0;
-	dirlist = get_dirlist(fname, dlen, 0);
+	dirlist = get_dirlist(fname, dlen, ignore_filters);
 	ret = non_perishable_cnt ? DR_NOT_EMPTY : DR_SUCCESS;
 
 	if (!dirlist->used)
@@ -335,8 +381,8 @@
 	pop_local_filters(save_filters);
 
 	if (ret == DR_NOT_EMPTY) {
-		rprintf(FINFO, "cannot delete non-empty directory: %s\n",
-			fname);
+		rprintf(FERROR, "cannot delete non-empty directory: %s\n",
+			full_fname(fname));
 	}
 	return ret;
 }
@@ -508,7 +554,10 @@
 	if (allowed_lull)
 		maybe_send_keepalive();
 
-	if (io_error && !ignore_errors) {
+	heartbeat(fbuf);
+
+	// Ignore "file vanished" IO errors by default WRT deleting items on the target -- if a source file is damaged/unreadable, we'll get an IOERR_GENERAL instead
+	if ((io_error & ~IOERR_VANISHED) && !ignore_errors) {
 		if (already_warned)
 			return;
 		rprintf(FINFO,
@@ -534,7 +583,9 @@
 
 	/* If an item in dirlist is not found in flist, delete it
 	 * from the filesystem. */
-	for (i = dirlist->used; i--; ) {
+	// BOMBICH
+	//for (i = dirlist->used; i--; ) {
+	for (i = 0; i < dirlist->used; i++ ) {
 		struct file_struct *fp = dirlist->files[i];
 		if (!F_IS_ACTIVE(fp))
 			continue;
@@ -591,8 +642,17 @@
 		}
 
 		if (verbose > 1 && file->flags & FLAG_TOP_DIR)
-			rprintf(FINFO, "deleting in %s\n", fbuf);
+			rprintf(FINFO, "deleting in %s\n", full_fname(fbuf));
 
+#ifdef PARSEABLE_OUTPUT
+		struct timeval now;
+		gettimeofday(&now, NULL);
+		unsigned long time_diff = msdiff(&last_update, &now);
+		if (time_diff > 100) {
+			last_update = now;
+			rprintf(FINFO, "S;;;DELETE;;;PROG;;;%d;;;CF;;;%s\n", (j * 100) / cur_flist->used, fbuf);
+		}
+#endif
 		if (link_stat(fbuf, &st, keep_dirlinks) < 0
 		 || !S_ISDIR(st.st_mode))
 			continue;
@@ -607,6 +667,9 @@
 
 int unchanged_attrs(const char *fname, struct file_struct *file, stat_x *sxp)
 {
+	if (verbose > 1)
+		fprintf(stderr, "unchanged_attrs(%s): %s\n", who_am_i(), full_fname(fname));
+
 #if !defined HAVE_LUTIMES || !defined HAVE_UTIMES
 	if (S_ISLNK(file->mode)) {
 		;
@@ -623,7 +686,7 @@
 		return 0;
 
 #ifdef SUPPORT_FILEFLAGS
-	if (preserve_fileflags && !S_ISLNK(file->mode) && sxp->st.st_flags != F_FFLAGS(file))
+	if (preserve_fileflags /*&& !S_ISLNK(file->mode)*/ && sxp->st.st_flags != F_FFLAGS(file))
 		return 0;
 #endif
 
@@ -664,6 +727,8 @@
 	     stat_x *sxp, int32 iflags, uchar fnamecmp_type,
 	     const char *xname)
 {
+	if (verbose > 1)
+		fprintf(stderr, "itemize(%s): (%d) %s, src flags: %#x, dst flags: %#x\n", who_am_i(), statret, full_fname(fnamecmp), F_FFLAGS(file), sxp->st.st_flags);
 	if (statret >= 0) { /* A from-dest-dir statret can == 1! */
 		int keep_time = !preserve_times ? 0
 		    : S_ISDIR(file->mode) ? preserve_times > 1 :
@@ -706,7 +771,7 @@
 		    && sxp->st.st_gid != (gid_t)F_GROUP(file))
 			iflags |= ITEM_REPORT_GROUP;
 #ifdef SUPPORT_FILEFLAGS
-		if (preserve_fileflags && !S_ISLNK(file->mode)
+		if (preserve_fileflags /*&& !S_ISLNK(file->mode)*/
 		 && sxp->st.st_flags != F_FFLAGS(file))
 			iflags |= ITEM_REPORT_FFLAGS;
 #endif
@@ -722,14 +787,20 @@
 		if (preserve_xattrs) {
 			if (!XATTR_READY(*sxp))
 				get_xattr(fnamecmp, sxp);
-			if (xattr_diff(file, sxp, 1))
+			if (xattr_diff(file, sxp, 1)) {
 				iflags |= ITEM_REPORT_XATTR;
+				if (verbose > 1)
+					fprintf(stderr, "itemize(%s): xattrs differ on (%s)\n", who_am_i(), full_fname(fnamecmp));
+			}
 		}
 #endif
 	} else {
 #ifdef SUPPORT_XATTRS
-		if (preserve_xattrs && xattr_diff(file, NULL, 1))
+		if (preserve_xattrs && xattr_diff(file, NULL, 1)) {
+			if (verbose > 1)
+				fprintf(stderr, "itemize(%s): statret = 0, xattrs differ on (%s)\n", who_am_i(), full_fname(fnamecmp));
 			iflags |= ITEM_REPORT_XATTR;
+		}
 #endif
 		iflags |= ITEM_IS_NEW;
 	}
@@ -763,15 +834,55 @@
 /* Perform our quick-check heuristic for determining if a file is unchanged. */
 int unchanged_file(char *fn, struct file_struct *file, STRUCT_STAT *st)
 {
-	if (st->st_size != F_LENGTH(file))
+	if (st->st_size != F_LENGTH(file)) {
+		//fprintf(stderr, "DEBUG: size differs||%s||d:%llu||s:%llu\n", full_fname(fn), st->st_size, F_LENGTH(file));
 		return 0;
+	}
+	
+	if (detect_case_conflicts) {
+		int fd = open(fn, O_RDONLY);
+		if (fd > 0) {
+			char realpath[MAXPATHLEN];
+			int ret = fcntl(fd, F_GETPATH, &realpath);
+			close(fd);
+			if (ret == 0) {
+				char *mypath = normalize_path(fn, False, NULL);
+				if (strcmp(mypath, realpath) != 0) {
+					fprintf(stderr, "DEBUG: Case conflict detected at %s. Actual path on destination: %s\n", full_fname(fn), realpath);
+					return 0;
+				}
+			}
+		}
+	}
 
 	/* if always checksum is set then we use the checksum instead
 	   of the file time to determine whether to sync */
-	if (always_checksum > 0 && S_ISREG(st->st_mode)) {
+#ifdef SUPPORT_HFS_COMPRESSION
+	if (always_checksum > 0 && S_ISREG(st->st_mode) && (st->st_flags & UF_COMPRESSED) == 0)
+#else
+	if (always_checksum > 0 && S_ISREG(st->st_mode) )
+#endif
+	{
 		char sum[MAX_DIGEST_LEN];
 		file_checksum(fn, sum, st->st_size);
-		return memcmp(sum, F_SUM(file), checksum_len) == 0;
+		
+		int checksumDiff = memcmp(sum, F_SUM(file), checksum_len);
+		if (cmp_time(st->st_mtime, file->modtime) == 0 && checksumDiff != 0) {
+			char *csumSrc = printableChecksum(F_SUM(file));
+			char *csumDst = printableChecksum(sum);
+			if (strstr(csumSrc, "00000000") != NULL) {
+				char *funkySum = printableChecksum(FUNKY_SUM(file));
+				fprintf(stderr, "DEBUG: Invalid source checksum for %s: %s [will try %s]\n", full_fname(fn), csumSrc, funkySum);
+				checksumDiff = memcmp(sum, FUNKY_SUM(file), checksum_len);
+			}
+
+			if (checksumDiff != 0)
+				fprintf(stderr, "File size and modification date match, but checksums were different: %s [%s vs. %s]\n", full_fname(fn), csumSrc, csumDst);
+			free(csumSrc);
+			free(csumDst);
+		}
+		
+		return checksumDiff == 0;
 	}
 
 	if (size_only > 0)
@@ -779,11 +890,15 @@
 
 	if (ignore_times)
 		return 0;
+	
+//	if (cmp_time(st->st_mtime, file->modtime))
+//		fprintf(stderr, "DEBUG: mod time differs||%s||d:%ld||s:%ld\n", full_fname(fn), st->st_mtime, file->modtime);
+//	else
+//		fprintf(stderr, "DEBUG: unchanged_file: mod time and size match for %s\n", full_fname(fn));
 
 	return cmp_time(st->st_mtime, file->modtime) == 0;
 }
 
-
 /*
  * set (initialize) the size entries in the per-file sum_struct
  * calculating dynamic block and checksum sizes.
@@ -1028,6 +1143,14 @@
 		pathjoin(cmpbuf, MAXPATHLEN, basis_dir[j], fname);
 		if (link_stat(cmpbuf, &sxp->st, 0) < 0 || !S_ISREG(sxp->st.st_mode))
 			continue;
+#ifdef SUPPORT_HFS_COMPRESSION
+		if (sxp->st.st_flags & UF_COMPRESSED) {
+			if (preserve_hfs_compression > 0) {
+				sxp->st.st_size = 0;
+			} else
+				sxp->st.st_flags &= ~UF_COMPRESSED;
+		}
+#endif
 		switch (match_level) {
 		case 0:
 			best_match = j;
@@ -1089,7 +1212,7 @@
 		if (itemizing)
 			itemize(cmpbuf, file, ndx, 0, sxp, ITEM_LOCAL_CHANGE, 0, NULL);
 		if (maybe_ATTRS_REPORT
-		 && ((!itemizing && verbose && match_level == 2)
+		 && ((!itemizing && verbose > 1 && match_level == 2)
 		  || (verbose > 1 && match_level == 3))) {
 			code = match_level == 3 ? FCLIENT : FINFO;
 			rprintf(code, "%s%s\n", fname,
@@ -1220,8 +1343,8 @@
 		 && !S_ISDIR(file->mode)) {
 			if (do_link(cmpbuf, fname) < 0) {
 				rsyserr(FERROR_XFER, errno,
-					"failed to hard-link %s with %s",
-					cmpbuf, fname);
+					"try_dests_non: failed to hard-link %s with %s",
+					cmpbuf, full_fname(fname));
 				return j;
 			}
 			if (preserve_hard_links && F_IS_HLINKED(file))
@@ -1396,6 +1519,8 @@
 					rsyserr(FERROR_XFER, errno,
 						"recv_generator: mkdir %s failed",
 						full_fname(dn));
+					if (errno == ENOSPC)
+						exit_cleanup(RERR_FILEIO);
 				}
 			}
 			if (fuzzy_dirlist) {
@@ -1421,6 +1546,33 @@
 		stat_errno = errno;
 	}
 
+	// BOMBICH
+	// filesystem_dev has to get set for the generator, otherwise make_file (flist.c) will 
+	// flag every directory as a mountpoint (FLAG_MOUNT_DIR), thus preventing delete_dir_contents()
+	// from deleting the item (e.g. to make room for an item of a different type -- doesn't affect --delete-* options)
+	if (one_file_system) {
+		if (file->flags & FLAG_TOP_DIR)
+			filesystem_dev = sx.st.st_dev;
+	}
+
+// BOMBICH
+#ifdef PARSEABLE_OUTPUT
+	size_t saved_file_length = 0;
+	if (statret == 0)
+		saved_file_length = sx.st.st_size; // For stats.total_unchanged_size, so we need the existing file size
+#endif
+
+#ifdef SUPPORT_HFS_COMPRESSION
+	if (statret == 0) {
+		if (sx.st.st_flags & UF_COMPRESSED) {
+			if (preserve_hfs_compression > 0) {
+				sx.st.st_size = 0;
+			} else
+				sx.st.st_flags &= ~UF_COMPRESSED;
+		}
+	}
+#endif
+	
 	if (ignore_non_existing > 0 && statret == -1 && stat_errno == ENOENT) {
 		if (is_dir) {
 			if (is_dir < 0)
@@ -1455,8 +1607,22 @@
 	}
 
 	if (is_dir) {
+		heartbeat(fname);
 		if (!implied_dirs && file->flags & FLAG_IMPLIED_DIR)
 			goto cleanup;
+
+		int saved_detect_case_conflicts = detect_case_conflicts;
+		if (detect_case_conflicts) {
+			detect_case_conflicts++;
+			int conflict_ndx = flist_find(cur_flist, file);
+			detect_case_conflicts = saved_detect_case_conflicts;
+			if (conflict_ndx > 0) {
+				struct file_struct *cfp = cur_flist->sorted[conflict_ndx];
+				fprintf(stderr, "Case conflict detected at %s: \"%s\"\n", full_fname(fname), cfp->basename);
+				goto skipping_dir_contents;
+			}
+		}
+		
 		if (is_dir < 0) {
 			/* In inc_recurse mode we want to make sure any missing
 			 * directories get created while we're still processing
@@ -1467,7 +1633,7 @@
 			 && (S_ISDIR(sx.st.st_mode)
 			  || delete_item(fname, sx.st.st_mode, del_opts | DEL_FOR_DIR) != 0))
 				goto cleanup; /* Any errors get reported later. */
-			if (do_mkdir(fname, file->mode & 0700) == 0)
+			if (do_mkdir(fname, file->mode & 0755) == 0)
 				file->flags |= FLAG_DIR_CREATED;
 			goto cleanup;
 		}
@@ -1487,6 +1653,8 @@
 			file->flags |= FLAG_MISSING_DIR;
 		}
 		real_ret = statret;
+//		init_stat_x(&real_sx);
+//		real_sx.st = sx.st;
 		real_sx = sx;
 		if (file->flags & FLAG_DIR_CREATED)
 			statret = -1;
@@ -1497,6 +1665,8 @@
 #ifdef SUPPORT_FORCE_CHANGE
 		if (force_change && !preserve_fileflags)
 			F_FFLAGS(file) = sx.st.st_flags;
+		if (verbose > 1)
+			fprintf(stderr, "recv_generator: F_FFLAGS(file): %#x (%s)\n", F_FFLAGS(file), fname);
 #endif
 		if (statret != 0 && basis_dir[0] != NULL) {
 			int j = try_dests_non(file, fname, ndx, fnamecmpbuf, &sx,
@@ -1527,28 +1697,35 @@
 				goto cleanup;
 			}
 		}
-#ifdef SUPPORT_XATTRS
-		if (preserve_xattrs && statret == 1)
-			copy_xattrs(fnamecmpbuf, fname);
-#endif
-		if (set_file_attrs(fname, file, real_ret ? NULL : &real_sx, NULL, 0)
-		    && verbose && code != FNONE && f_out != -1)
-			rprintf(code, "%s/\n", fname);
 
 		/* We need to ensure that the dirs in the transfer have writable
 		 * permissions during the time we are putting files within them.
 		 * This is then fixed after the transfer is done. */
 #ifdef SUPPORT_FORCE_CHANGE
+		//fprintf(stderr, "recv_generator: Calling make_mutable on %s. Mode: %o, fileflags: %d\n", full_fname(fname), file->mode, F_FFLAGS(file));
 		if (force_change && F_FFLAGS(file) & force_change
 		 && make_mutable(fname, file->mode, F_FFLAGS(file), force_change))
 			need_retouch_dir_perms = 1;
 #endif
+
+#ifdef SUPPORT_XATTRS
+		// Copy directory xattrs for a directory that already existed
+		if (preserve_xattrs && statret == 1)
+			copy_xattrs(fnamecmpbuf, fname);
+#endif
+		if (set_file_attrs(fname, file, real_ret ? NULL : &real_sx, NULL, 0)
+		    && verbose > 1 && code != FNONE && f_out != -1)
+			rprintf(code, "%s/\n", fname);
+
 #ifdef HAVE_CHMOD
 		if (!am_root && !(file->mode & S_IWUSR) && dir_tweaking) {
 			mode_t mode = file->mode | S_IWUSR;
-			if (do_chmod(fname, mode, 0) < 0) {
+			// BOMBICH: I set the third argument to NO_FFLAGS to force
+			// a stat of the folder, otherwise do_chmod might not call
+			// make_mutable properly
+			if (do_chmod(fname, mode, NO_FFLAGS) < 0) {
 				rsyserr(FERROR_XFER, errno,
-					"failed to modify permissions on %s",
+					"recv_generator: failed to modify permissions on %s",
 					full_fname(fname));
 			}
 			need_retouch_dir_perms = 1;
@@ -1584,12 +1761,18 @@
 #ifdef SUPPORT_FORCE_CHANGE
 	if (force_change && !preserve_fileflags)
 		F_FFLAGS(file) = sx.st.st_flags;
+	if (verbose > 1)
+		fprintf(stderr, "recv_generator(2): F_FFLAGS(file): %#x (%s)\n", F_FFLAGS(file), fname);
 #endif
 
 #ifdef SUPPORT_HARD_LINKS
+	if (verbose > 1)
+		fprintf(stderr, "recv_generator(%s): F_HLINK_NOT_FIRST(file) is %d for (%s)\n", who_am_i(), F_HLINK_NOT_FIRST(file), full_fname(fname));
+	
 	if (preserve_hard_links && F_HLINK_NOT_FIRST(file)
-	 && hard_link_check(file, ndx, fname, statret, &sx, itemizing, code))
+	 && hard_link_check(file, ndx, fname, statret, &sx, itemizing, code)) {
 		goto cleanup;
+	}
 #endif
 
 	if (preserve_links && S_ISLNK(file->mode)) {
@@ -1652,7 +1835,7 @@
 		}
 #endif
 		if (do_symlink(sl, fname) != 0) {
-			rsyserr(FERROR_XFER, errno, "symlink %s -> \"%s\" failed",
+			rsyserr(FERROR_XFER, errno, "recv_generator: symlink %s -> \"%s\" failed",
 				full_fname(fname), sl);
 		} else {
 			set_file_attrs(fname, file, NULL, NULL, 0);
@@ -1660,7 +1843,7 @@
 				itemize(fname, file, ndx, statret, &sx,
 					ITEM_LOCAL_CHANGE|ITEM_REPORT_CHANGE, 0, NULL);
 			}
-			if (code != FNONE && verbose)
+			if (code != FNONE && verbose > 1)
 				rprintf(code, "%s -> %s\n", fname, sl);
 #ifdef SUPPORT_HARD_LINKS
 			if (preserve_hard_links && F_IS_HLINKED(file))
@@ -1740,7 +1923,7 @@
 				(long)major(rdev), (long)minor(rdev));
 		}
 		if (do_mknod(fname, file->mode, rdev) < 0) {
-			rsyserr(FERROR_XFER, errno, "mknod %s failed",
+			rsyserr(FERROR_XFER, errno, "recv_generator: mknod %s failed",
 				full_fname(fname));
 		} else {
 			set_file_attrs(fname, file, NULL, NULL, 0);
@@ -1748,7 +1931,7 @@
 				itemize(fname, file, ndx, statret, &sx,
 					ITEM_LOCAL_CHANGE|ITEM_REPORT_CHANGE, 0, NULL);
 			}
-			if (code != FNONE && verbose)
+			if (code != FNONE && verbose > 1)
 				rprintf(code, "%s\n", fname);
 #ifdef SUPPORT_HARD_LINKS
 			if (preserve_hard_links && F_IS_HLINKED(file))
@@ -1763,16 +1946,16 @@
 	if (!S_ISREG(file->mode)) {
 		if (solo_file)
 			fname = f_name(file, NULL);
-		rprintf(FINFO, "skipping non-regular file \"%s\"\n", fname);
+		rprintf(FERROR, "recv_generator: skipping non-regular file %s\n", fname);
 		goto cleanup;
 	}
 
 	if (max_size > 0 && F_LENGTH(file) > max_size) {
-		if (verbose > 1) {
+//		if (verbose > 1) {
 			if (solo_file)
 				fname = f_name(file, NULL);
-			rprintf(FINFO, "%s is over max-size\n", fname);
-		}
+			rprintf(FERROR, "recv_generator: %s is over max-size (27)\n", full_fname(fname));
+//		}
 		goto cleanup;
 	}
 	if (min_size > 0 && F_LENGTH(file) < min_size) {
@@ -1783,7 +1966,6 @@
 		}
 		goto cleanup;
 	}
-
 	if (update_only > 0 && statret == 0
 	    && cmp_time(sx.st.st_mtime, file->modtime) > 0) {
 		if (verbose > 1)
@@ -1794,10 +1976,118 @@
 #endif
 		goto cleanup;
 	}
-
+	
 	fnamecmp = fname;
 	fnamecmp_type = FNAMECMP_FNAME;
 
+// BOMBICH
+#ifdef PARSEABLE_OUTPUT
+	struct timeval now;
+	gettimeofday(&now, NULL);
+	
+	// The Recv generator gets a list of every single file sent by the sender whether it will
+	// eventually be copied or not. Here we optionally print out the current file that is being
+	// received for consideration to give the user a general idea of where rsync is within their fs
+
+	// Print update information every fifth of a second. If a file changed, print update
+	// information as long as the file is larger than 1MB or time since last update > tenth of a second
+
+	unsigned long time_diff = msdiff(&last_update, &now);
+	if (F_LENGTH(file) > 10000000 && always_checksum) {
+		// If the file is > 10MB and we're calculating a checksum, post an update now 
+		// so the user can see the file that might take a while to read
+		rprintf(FINFO, "S;;;CP;;;CF;;;%s\n", fname);
+	}
+	int fileUnchanged;
+	fileUnchanged = unchanged_file(fnamecmp, file, &sx.st);
+
+	// Sparse file support
+	int fileIsSparse = 0;
+	struct stat sps;
+	char src[MAXPATHLEN];
+	char dst[MAXPATHLEN];
+	off_t physicalSize, logicalSize;
+
+	if (/*sparse_files && */!fileUnchanged && (F_FFLAGS(file) & UF_COMPRESSED) == 0 && srcRoot != NULL && dstRoot != NULL) {
+		// We do this check even when we're not supporting sparse files so we can see what kind of sparse files we aren't supporting properly
+		pathjoin(src, MAXPATHLEN, srcRoot, fname);
+		pathjoin(dst, MAXPATHLEN, dstRoot, fname);
+
+		if (stat(src, &sps) != 0) {
+			fprintf(stderr, "DEBUG: Failed to stat '%s': %d\n", src, errno);
+		} else {
+			physicalSize = S_BLKSIZE * sps.st_blocks;
+			logicalSize = sps.st_size;
+			if (logicalSize > physicalSize) {
+				fileIsSparse = 1;
+				saved_file_length = (S_BLKSIZE * sx.st.st_blocks);
+			}
+		}
+	}
+
+	if (fileUnchanged && !(preserve_hard_links && F_HLINK_NOT_LAST(file))) {
+		stats.total_unchanged_size += saved_file_length;
+		stats.total_unchanged_count++;
+	}
+	
+	static int localNdx = 0; // We'll use this to avoid printing output for redos
+	if (ndx > localNdx && ((fileUnchanged && time_diff > 200) || (!fileUnchanged && (F_LENGTH(file) > 1024000 || time_diff > 100)))) {
+		last_update = now;
+		localNdx = ndx;
+		
+		if (inc_recurse)
+			rprintf(FINFO, "S;;;CP;;;NOI;;;%d;;;TUF;;;%d;;;TUS;;;%s;;;CF;;;%s\n", stats.num_files - stats.num_dirs, stats.total_unchanged_count, human_num(stats.total_unchanged_size), fname);
+		else
+			if (am_server)
+				rprintf(FINFO, "S;;;CP;;;TUF;;;%d;;;TUS;;;%s;;;CF;;;%s\n", stats.total_unchanged_count, human_num(stats.total_unchanged_size), fname);
+			else
+				// Remote source. We don't use this, though, we force incremental recursion with a remote source
+				rprintf(FINFO, "S;;;CP;;;TUF;;;%d;;;TUS;;;%s\n", stats.total_unchanged_count, human_num(stats.total_unchanged_size));
+	}
+#endif
+	
+	if (fileIsSparse && !sparse_files && physicalSize > 0) {
+		// Treat it like an ordinary file. This change is only required for the logic in the free-space-check block that follows
+		fprintf(stderr, "DEBUG: Physical size: %lld, logical size: %lld, difference: %lld [%s]\n", physicalSize, logicalSize, logicalSize - physicalSize, src);
+		fileIsSparse = 0;
+	}
+	
+	// Bail on this file if it is larger than the amount of free space remaining
+	// Only do this check for files larger than 512MB
+	off_t req_len = fileIsSparse ? physicalSize : F_LENGTH(file);
+	if (!inplace && !fileUnchanged && req_len > 512*1024*1024) {
+		struct statfs fsb;
+		const char *parent = file->dirname ? file->dirname : ".";
+		if (statfs(parent, &fsb) == 0) {
+			long long fs = fsb.f_bavail * fsb.f_bsize;
+			if (fs < req_len) {
+				rprintf(FERROR_XFER, "recv_generator: Insufficient space to accommodate %s. ;;;REQ;;;%lld;;; Skipping this file... (%d)\n",
+						full_fname(fname), req_len, ENOSPC);
+				goto cleanup;
+			}
+		} else
+			rprintf(FINFO, "recv_files: Failed to statfs %s: %s\n", full_fname(fname), strerror(errno));
+	}
+	
+	// If this file looks like a sparse file and we have sparse file support, copy it with copy_sparse_file
+	if (fileIsSparse) { // implies !fileUnchanged (that the file will be copied)
+		errno = 0;
+		if (copy_sparse_file(src, dst, sps.st_mode, logicalSize, physicalSize, sparse_files) == 0) {
+			struct stat spd;
+			if (stat(dst, &spd) != 0) {
+				fprintf(stderr, "DEBUG: Copied sparse file '%s' successfully, but failed to stat the resulting file: %d\n", dst, errno);
+			} else {
+				fileUnchanged = 1;
+				sx.st = spd;
+				statret = 0;
+			}
+		} else if (errno == EACCES && physicalSize == 0) {
+			fileUnchanged = 1;
+			goto return_with_success;
+		}
+	}
+
+	
 	if (statret == 0 && !S_ISREG(sx.st.st_mode)) {
 		if (delete_item(fname, sx.st.st_mode, del_opts | DEL_FOR_FILE) != 0)
 			goto cleanup;
@@ -1840,6 +2130,15 @@
 				rprintf(FINFO, "fuzzy basis selected for %s: %s\n",
 					fname, fnamecmpbuf);
 			}
+#ifdef SUPPORT_HFS_COMPRESSION
+		// TODO: This seems misplaced...
+		if (sx.st.st_flags & UF_COMPRESSED) {
+			if (preserve_hfs_compression > 0) {
+				sx.st.st_size = 0;
+			} else
+				sx.st.st_flags &= ~UF_COMPRESSED;
+		} else
+#endif
 			sx.st.st_size = F_LENGTH(fuzzy_file);
 			statret = 0;
 			fnamecmp = fnamecmpbuf;
@@ -1854,7 +2153,7 @@
 			goto cleanup;
 		}
 #endif
-		if (stat_errno == ENOENT)
+		if (stat_errno == ENOENT || stat_errno == ENAMETOOLONG)
 			goto notify_others;
 		rsyserr(FERROR_XFER, stat_errno, "recv_generator: failed to stat %s",
 			full_fname(fname));
@@ -1865,11 +2164,19 @@
 		;
 	else if (fnamecmp_type == FNAMECMP_FUZZY)
 		;
-	else if (unchanged_file(fnamecmp, file, &sx.st)) {
+#ifdef PARSEABLE_OUTPUT
+	else if (fileUnchanged)
+#else
+	else if (unchanged_file(fnamecmp, file, &sx.st))
+#endif
+	{
 		if (partialptr) {
 			do_unlink(partialptr);
 			handle_partial_dir(partialptr, PDIR_DELETE);
 		}
+
+		if (verbose > 1)
+			fprintf(stderr, "recv_generator: Calling set_file_attrs: ITEM_REPORT_XATTR: %d (%s)\n", file->flags & ITEM_REPORT_XATTR, fname);
 		set_file_attrs(fname, file, &sx, NULL, maybe_ATTRS_REPORT);
 		if (itemizing)
 			itemize(fnamecmp, file, ndx, statret, &sx, 0, 0, NULL);
@@ -1899,6 +2206,14 @@
 		fnamecmp = partialptr;
 		fnamecmp_type = FNAMECMP_PARTIAL_DIR;
 		statret = 0;
+#ifdef SUPPORT_HFS_COMPRESSION
+		if (sx.st.st_flags & UF_COMPRESSED) {
+			if (preserve_hfs_compression > 0) {
+				sx.st.st_size = 0;
+			} else
+				sx.st.st_flags &= ~UF_COMPRESSED;
+		}
+#endif
 	}
 
 	if (!do_xfers)
@@ -1927,7 +2242,7 @@
 
 	/* open the file */
 	if ((fd = do_open(fnamecmp, O_RDONLY, 0)) < 0) {
-		rsyserr(FERROR, errno, "failed to open %s, continuing",
+		rsyserr(FERROR, errno, "recv_generator: failed to open %s, continuing",
 			full_fname(fnamecmp));
 	  pretend_missing:
 		/* pretend the file didn't exist */
@@ -1951,7 +2266,7 @@
 			goto pretend_missing;
 		}
 		if (robust_unlink(backupptr) && errno != ENOENT) {
-			rsyserr(FERROR_XFER, errno, "unlink %s",
+			rsyserr(FERROR_XFER, errno, "recv_generator: unlink %s",
 				full_fname(backupptr));
 			unmake_file(back_file);
 			back_file = NULL;
@@ -1960,6 +2275,8 @@
 		}
 		if ((f_copy = do_open(backupptr, O_WRONLY | O_CREAT | O_TRUNC | O_EXCL, 0600)) < 0) {
 			int save_errno = errno ? errno : EINVAL; /* 0 paranoia */
+			if (verbose)
+				fprintf(stderr, "DEBUG: recv_generator: do_open() failed: %d |%s\n", errno, backupptr);
 			if (errno == ENOENT && make_bak_dir(backupptr) == 0) {
 				if ((f_copy = do_open(backupptr, O_WRONLY | O_CREAT | O_TRUNC | O_EXCL, 0600)) < 0)
 					save_errno = errno ? errno : save_errno;
@@ -1967,7 +2284,7 @@
 					save_errno = 0;
 			}
 			if (save_errno) {
-				rsyserr(FERROR_XFER, save_errno, "open %s", full_fname(backupptr));
+				rsyserr(FERROR_XFER, save_errno, "recv_generator: open backup file %s", full_fname(backupptr));
 				unmake_file(back_file);
 				back_file = NULL;
 				close(fd);
@@ -1997,12 +2314,16 @@
 	write_ndx(f_out, ndx);
 	if (itemizing) {
 		int iflags = ITEM_TRANSFER;
-		if (always_checksum > 0)
-			iflags |= ITEM_REPORT_CHANGE;
+//		if (always_checksum > 0)
+//			iflags |= ITEM_REPORT_CHANGE;
 		if (fnamecmp_type != FNAMECMP_FNAME)
 			iflags |= ITEM_BASIS_TYPE_FOLLOWS;
 		if (fnamecmp_type == FNAMECMP_FUZZY)
 			iflags |= ITEM_XNAME_FOLLOWS;
+		if (preserve_xattrs)
+			iflags |= ITEM_REPORT_XATTR; // Must be on any time a file is transferred
+		if (verbose > 1)
+			fprintf(stderr, "recv_generator(%s): itemizing (%s)\n", who_am_i(), full_fname(fnamecmp));
 		itemize(fnamecmp, file, -1, real_ret, &real_sx, iflags, fnamecmp_type,
 			fuzzy_file ? fuzzy_file->basename : NULL);
 #ifdef SUPPORT_ACLS
@@ -2017,20 +2338,39 @@
 
 	if (!do_xfers) {
 #ifdef SUPPORT_HARD_LINKS
-		if (preserve_hard_links && F_IS_HLINKED(file))
+		if (preserve_hard_links && F_IS_HLINKED(file)) {
+			if (verbose > 1)
+				fprintf(stderr, "recv_generator(%s): Calling finish_hard_link for (%s)\n", who_am_i(), full_fname(fname));
 			finish_hard_link(file, fname, ndx, &sx.st, itemizing, code, -1);
+		}
 #endif
 		goto cleanup;
 	}
 	if (read_batch)
 		goto cleanup;
 
+#ifdef SUPPORT_HFS_COMPRESSION
+	if (F_FFLAGS(file) & UF_COMPRESSED) {
+		// At this point the attrs have already been copied, we don't need to transfer a data fork
+		// If my filesystem doesn't support HFS compression, the existing file's content 
+		// will not be automatically truncated, so we'll do that manually here
+		if (!fs_supports_hfs_compression && sx.st.st_size > 0) {
+			if (verbose > 1)
+				fprintf(stderr, "recv_generator(%s): Truncating file on fs that doesn't support HFS compression (%s)\n", who_am_i(), full_fname(fname));
+			if (ftruncate(fd, 0) == 0)
+				sx.st.st_size = 0;
+		}
+	}
+#endif
+	
 	if (statret != 0 || whole_file)
 		write_sum_head(f_out, NULL);
 	else if (sx.st.st_size <= 0) {
 		write_sum_head(f_out, NULL);
 		close(fd);
 	} else {
+		if (verbose > 1)
+			fprintf(stderr, "recv_generator(%s): Calling generate_and_send_sums for (%s)\n", who_am_i(), full_fname(fname));
 		if (generate_and_send_sums(fd, sx.st.st_size, f_out, f_copy) < 0) {
 			rprintf(FWARNING,
 			    "WARNING: file is too large for checksum sending: %s\n",
@@ -2079,6 +2419,8 @@
 	int new_last_ndx;
 	struct file_list *save_flist = cur_flist;
 
+	if (verbose > 1)
+		fprintf(stderr, "handle_skipped_hlink: Calling skip_hard_link()\n");
 	/* If we skip the last item in a chain of links and there was a
 	 * prior non-skipped hard-link waiting to finish, finish it now. */
 	if ((new_last_ndx = skip_hard_link(file, &cur_flist)) < 0)
@@ -2087,6 +2429,8 @@
 	file = cur_flist->files[new_last_ndx - cur_flist->ndx_start];
 	cur_flist->in_progress--; /* undo prior increment */
 	f_name(file, fbuf);
+	if (verbose > 1)
+		fprintf(stderr, "handle_skipped_hlink: Calling recv_generator() with %s\n", full_fname(fbuf));
 	recv_generator(fbuf, file, new_last_ndx, itemizing, code, f_out);
 
 	cur_flist = save_flist;
